case $CONFIG in
'')
	if test -f config.sh; then TOP=.;
	elif test -f ../config.sh; then TOP=..;
	elif test -f ../../config.sh; then TOP=../..;
	elif test -f ../../../config.sh; then TOP=../../..;
	elif test -f ../../../../config.sh; then TOP=../../../..;
	else
		echo "Can't find config.sh."; exit 1
	fi
	. $TOP/config.sh
	;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting txt2dig (with variable substitutions)"
: This section of the file will have variable substitutions done on it.
: Move anything that needs config subs from !NO!SUBS! section to !GROK!THIS!.
: Protect any dollar signs and backticks that you do not want interpreted
: by putting a backslash in front.  You may delete these comments.
$spitshell >txt2dig <<!GROK!THIS!
#!$perlpath
#
#	txt2dig - turn multiple messages into an RFC1153 digest message
#	distributed as part of AUTO-FAQ
#	Copyright (c) 1994 by Ian Kluft
#	see distribution conditions included with AUTO-FAQ
#

# make sure we're running in PERL
$startperl

# print usage message
sub usage
{
	local ( @msgs ) = @_;

	foreach \$msg (@msgs) {
		print STDERR "\$prog: \$msg\n";
	}
	print STDERR "usage: \$prog listname preamble [message [...]]\n";
	print STDERR "   listname is the name of the list or material begin ".
		"digested\n";
	print STDERR "   preamble is the filename of the digest preamble\n";
	print STDERR "   message is an RFC-822 message file to be included in ".
		"the digest\n";
	exit 1;
}

# print fatal error message
sub fatal
{
	local ( @msgs ) = @_;

	foreach \$msg (@msgs) {
		print STDERR "\$prog: \$msg\n";
	}
	exit 1;
}

# constants
\$hyphen30=("-" x 30);
\$hyphen70=("-" x 70);

# process command line
\$prog = \$0; \$prog =~ s/.*\/([^\/]*)\$/\1/;
if ( \$#ARGV < 1 ) {
	&usage;
}
( \$digest_name, \$preamble, @dmsgs ) = @ARGV;

# check that all files exist and are readable before proceeding
foreach \$file ( \$preamble, @dmsgs ) {
	if ( ! -e \$file ) {
		&usage ( "\$file does not exist" );
	}
	if ( ! -f \$file ) {
		&usage ( "\$file is not a file" );
	}
	if ( ! -r \$file ) {
		&usage ( "\$file is not a readable file" );
	}
}

# to-do later: add optional full digest header generation here

# print preamble
if ( !open ( preamble, \$preamble )) {
	&fatal ( "could not open preamble \$preamble: \$!" );
}
while ( <preamble> ) {
	s/^(\$hyphen30)\$/ \1/;  # add a space if the line is 30 hyphens
	print \$_;
}
close preamble;
print "\n";

# print table of contents (considered part of preamble for RFC 1153 purposes)
\$msg_num=1;
foreach \$dmsg ( @dmsgs ) {
	# open message
	if ( !open ( message, \$dmsg )) {
		&fatal ( "could not open message \$dmsg: \$!" );
	}

	# scan for subject, print it if found
	while ( <message> ) {
		chop;
		if ( /^\$/ ) {
			# if we found end of headers, there isn't a subject
			print "   \$msg_num: (no subject)\n";
			last;
		}
		if ( /^Subject: (.*)\$/ ) {
			# if we found subject, we can print it and exit loop
			print "   \$msg_num: \$1\n";
			last;
		}
	}
	close message;
	\$msg_num++;
}
print "\n";

# 70-hyphen line required by RFC 1153
print "\$hyphen70\n";
print "\n";

foreach \$dmsg ( @dmsgs ) {
	# print message
	if ( !open ( message, \$dmsg )) {
		&fatal ( "could not open message \$dmsg: \$!" );
	}

	undef %header;
	\$in_hdr=1;
	\$last_header="";
	while ( <message> ) {
		# process end of headers (first blank line)
		if ( /^\$/ && \$in_hdr ) {
			\$in_hdr = 0;
			for \$hdr ( "Date", "From", "To", "Cc", "Subject",
				"Message-ID", "Keywords", "Summary" )
			{
				( defined \$header{\$hdr} ) && 
					print "\$hdr: \$header{\$hdr}\n";
			}
			print "\n";
			next;
		}

		# differentiate between message header and body
		if ( \$in_hdr ) {
			# save header line - we won't use all of them
			chop;
			/^([^:]*): (.*)/;
			\$header{\$1}=\$2;
			\$last_header=\$1;
			next;
		} else {
			# print body line
			s/^(\$hyphen30)\$/ \1/; # add space to 30-hyphen line
			print \$_;
		}
	}
	close message;


	# 30-hyphen line required by RFC 1153
	print "\n";
	print "\$hyphen30\n";
	print "\n";
}

# print RFC 1153 trailer
\$trailer_line="End of \$digest_name Digest";
print "\$trailer_line\n";
print "".("*" x length(\$trailer_line))."\n";
!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
$spitshell >>txt2dig <<'!NO!SUBS!'
!NO!SUBS!
chmod 755 txt2dig
$eunicefix txt2dig
